#ifndef __TOOLS_TCC
#define __TOOLS_TCC

#include <fftw3.h>

namespace mimas {

template< typename T >
mm_image< T > multi_array_to_mm_image( const boost::multi_array< T, 2 > &x )
{
  mm_image< T > retVal; retVal.init( x.shape()[ 1 ], x.shape()[ 0 ] );
  retVal.rawData() = x;
  return retVal;
}

}

#endif
