//
// Filter by colour - brainstorming
// $Header: /cvs/mimas/examples/colourFilter/main.cc,v 1.8 2004/12/06 18:35:24 engjw Exp $
//


#include <iostream>
#include <fstream>
#include "mm_image.h"
#include "mm_image_fileinput.h"
#include "mm_image_qtoutput.h"
#include <qapplication.h>

using namespace std;
using namespace mimas;


// WARNING - method is deprecated by use of mm_image_colour!!!!!


int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   QApplication app( argc, argv );
	mm_image< unsigned char > someimage;
   mm_image< mm_rgba< unsigned char > > img;
   mm_image_qtoutput< unsigned char > display( app );
	// int i;

	const char *imagefile="image0086.ppm";
   ifstream stream( imagefile, ios::binary );
   stream >> img;

	int redRef, greenRef, blueRef, redRange, blueRange, greenRange;

	// First filter
	redRef=175;
	greenRef=131;
	blueRef=103;
	redRange=30;
	greenRange=20;
	blueRange=20;

   someimage.init( img.getWidth(), img.getHeight() );


	for (int j=0; j<img.getHeight(); j++)
		for (int i=0; i<img.getWidth(); i++)
		{
			int r,g,b;
			r=img.pixel(i,j).getRed();
			g=img.pixel(i,j).getGreen();
			b=img.pixel(i,j).getBlue();

			if ((abs(r-redRef)<=redRange) && (abs(g-greenRef)<=greenRange) && (abs(b-blueRef)<=blueRange))
           someimage.setPixel(i,j,0);
			else
				someimage.setPixel(i,j,255);
		}



	// Second filter
	redRef=117;
	greenRef=101;
	blueRef=83;
	redRange=30;
	greenRange=10;
	blueRange=10;

	for (int j=0; j<img.getHeight(); j++)
		for (int i=0; i<img.getWidth(); i++)
		{
			int r,g,b;
			r=img.pixel(i,j).getRed();
			g=img.pixel(i,j).getGreen();
			b=img.pixel(i,j).getBlue();

			if ((abs(r-redRef)<=redRange) && (abs(g-greenRef)<=greenRange) && (abs(b-blueRef)<=blueRange))
				someimage.setPixel(i,j,0);
		}

   display << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
