#include <mm_image_v4linput.h>
#include <mm_image_qtoutput.h>

using namespace mimas;
using namespace std;

int main( int argc, char *argv[] )
{
  int retVal;
  try {
    QApplication app( argc, argv );
    mm_image_qtoutput< mm_rgba< unsigned char > > display( app );
    mm_image_v4linput< mm_rgba< unsigned char > > grabber( "/dev/video" );
    while ( true ) {
      mm_image< mm_rgba< unsigned char > > image;
      grabber >> image;
      display << image;
    };
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

