#ifndef MM_IMAGE_FILESINPUT_TCC
#define MM_IMAGE_FILESINPUT_TCC

#include <fstream>

namespace mimas {

template< typename T >
void mm_image_filesinput< T >::read( mm_image< T > &image )
  throw (mm_exception)
{
  if ( fileNames.empty() )
    state = false;
  else {
    std::string fileName = fileNames.front();
    fileNames.pop_front();
    std::ifstream file( fileName.c_str(), std::ios::binary );
    MMERROR( file >> image, mm_exception, ,
             "Error loading file \"" << fileName << "\"." );
  };
}

};

#endif
