#ifndef __FINDTUXWIDGET_H
#define __FINDTUXWIDGET_H

#include <boost/shared_ptr.hpp>
#include <qwidget.h>
#include <list>
#include "mm_image.h"
#include "mm_line.h"
#include "mm_pol_match.h"

class FindTuxWidget: public QWidget
{
 public:
  FindTuxWidget( QWidget *parent, const char *name = 0, WFlags f = 0 );
  virtual ~FindTuxWidget(void);
 protected:
  virtual void paintEvent( QPaintEvent * );
  mimas::mm_image<int> im;
  mimas::mm_pol_match_ptr_list matches;
  std::list< boost::shared_ptr< mimas::mm_line > > ml;
};

#endif
