#ifndef __PGHDEMOWIDGET_H
#define __PGHDEMOWIDGET_H

#include <boost/shared_ptr.hpp>
#include <qwidget.h>
#include "mm_pgh_scene.h"

class PghDemoWidget: public QWidget
{
 public:
  PghDemoWidget( QWidget *parent, const char *name = 0, WFlags f = 0 );
 protected:
  virtual void timerEvent( QTimerEvent * );
  virtual void paintEvent( QPaintEvent * );
  int count;
  mimas::mm_pgh_scene	camera_scene;
  mimas::mm_pgh_2dobject_ptr clipper;
  mimas::mm_object_instance_list_ptr oil;
};

#endif
