#ifndef __SLAPTOOLWIDGET_H
#define __SLAPTOOLWIDGET_H

#include <boost/shared_ptr.hpp>
#include <qwidget.h>
#include <list>
#include "mm_line.h"

class SlapToolWidget: public QWidget
{
 public:
  SlapToolWidget( QWidget *parent, const char *name = 0, WFlags f = 0 );
 protected:
  virtual void paintEvent( QPaintEvent * );
  std::list< boost::shared_ptr< mimas::mm_line > > l_lines;
};

#endif
