//
// Webcam grabber tool
//


#ifndef MM_WEBCAM_TOOL_H
#define MM_WEBCAM_TOOL_H

#include <iostream>
#include <cmath>
#include <cstdio>
#include "mm_image.h"
#include "mm_rgba.h"
#include "mm_video4linux.h"

namespace mimas {

/**
 * Wecam tool
 * @author Bala Amavasai (bala@amavasai.org)
 * @date Thu Oct 16 12:04:45 BST 2003
 * $Header: /cvs/mimas/include/mm_webcam_tool.h,v 1.13 2004/12/09 23:27:19 engjw Exp $
 */



class mm_webcam_tool : public mm_video4linux
{
	private:

	public:
		mm_webcam_tool(void); ///< constructor
      void grab(mm_image< unsigned char > &imagein) throw (mm_exception); ///< grab an image and store it as grayscale
		void grab(mm_image< mm_rgba< unsigned char > > &imagein) throw (mm_exception); ///< grab an image and store it in colour
};
}

#endif
